#include "testApp.h"


//--------------------------------------------------------------
void testApp::setup(){

	ofSetVerticalSync(true);
	ofSetFrameRate(20);

	ofBackground(255, 255, 255);

	//  
	bgImage.loadImage("arduino.png");
	//  : ( ,  )
	font.loadFont("franklinGothic.otf", 20);

	// the connection speed has been changing in the
	// arduino firmata sketch. in 0017 it's 57600
	// if you have problems try commenting/uncommenting
	// to change the speed

	//   
	ard.connect("\\\\.\\COM19", 57600);
	// ard.connect("/dev/ttyUSB0", 57600);

	bSetupArduino	= false;	// flag so we setup arduino when its ready, you don't need to touch this :)

	mouseX=0;
	mouseY=0;

	for(int i=0; i<PIN_COUNT; i++){
		pins[i]=0;
	}
}

//--------------------------------------------------------------
void testApp::update(){

	if ( ard.isArduinoReady()){

		// 1st: setup the arduino if haven't already:
		if (bSetupArduino == false){
			setupArduino();
			bSetupArduino = true;	// only do this once
		}
		// 2nd do the update of the arduino
		updateArduino();
	}

}

//--------------------------------------------------------------
void testApp::setupArduino(){

	//      
	// ( 0  1 ..      COM-)
	for (int i = 2; i <= 13; i++){
		ard.sendDigitalPinMode(i, ARD_OUTPUT);
	}
}

//--------------------------------------------------------------
void testApp::updateArduino(){

	//   
	//ard.update();

}


//--------------------------------------------------------------
void testApp::draw(){
	//   (  )
	bgImage.draw(0,0);

	if (!ard.isArduinoReady()){
		font.drawString("arduino not ready\n", 545, 40);
	} 

	//       :)
	if(mouseX || mouseY){
		ofSetColor(50, 100, 200);
		font.drawString("x: " + ofToString(mouseX) + " y: " + ofToString(mouseY), 600, 100);
		ofSetColor(255, 255, 255);
		
		//ofDrawBitmapString("x: " + ofToString(mouseX) + " y: " + ofToString(mouseY), 545, 130);
	}

	float x,y, w=15, h=15;
	//   
	for(int i=2; i<=13; i++){
		//      -  
		if(pins[i]){
			ofSetColor(200, 0, 0);
		}
		else{
			ofSetColor(0, 200, 0);
		}
		y = 90;
		if(i<=7){
			x = 540 - 20*(i-1) + 10;
		}
		else{
			x = 400 - 20*(i-7) + 10;
		}
		//  
		ofRect(x, y, w, h);
	}
	ofSetColor(255, 255, 255);
}

//--------------------------------------------------------------
void testApp::keyPressed  (int key){

}

//--------------------------------------------------------------
void testApp::keyReleased(int key){

}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){

}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
	printf("[click] x: %d y: %d\n", x, y);
	mouseX=x;
	mouseY=y;

	//    Y
	if(mouseY>90 && mouseY<105){
		printf("[i] Y ok!\n");

		//    X
		if(mouseX>290 && mouseX<560){
			//    :)
			for(int i=2; i<=13; i++){
				float xx;
				if(i<=7){
					xx = 540 - 20*(i-1) + 10;
				}
				else{
					xx = 400 - 20*(i-7) + 10;
				}
				if( abs(xx+7.5-x)<13 ){

					printf("[i] X ok! pin: %d\n", i);

					//   
					if(pins[i]){
						ard.sendDigital(i, ARD_LOW);
						pins[i]=0;
					}
					else{
						ard.sendDigital(i, ARD_HIGH);
						pins[i]=1;
					}
					break;
				}
			}
		}
	}
	/*
	13 - 300
	12 - 320
	11 - 340
	10 - 360
	9 - 380
	8 - 400
	7 - 440
	6 - 460
	5 - 480
	4 - 500
	3 - 520
	2 - 540
	*/
}

//--------------------------------------------------------------
void testApp::mouseReleased(int x, int y, int button){
}

//--------------------------------------------------------------
void testApp::windowResized(int w, int h){

}
